# -*- coding: utf-8 -*-
# $Id$

module MakeProj
  ##
  #	構成(Release, Debug, ...)
  #
  class Configuration < Property
    #
    def initialize(name, parent)
      super(parent)
      @name, @platform = name.split('|', 2)
      @parent = parent
      if !@name or !@platform
        raise(Error, "illegal configuration, '#{name}'")
      end
      if /debug/i.match(@name)
        @is_debug = true
        compile_options.set('Optimization', 'Disabled')
        append_macro('_DEBUG')
      else
        @is_debug = false
        compile_options.set('Optimization', 'MaxSpeed')
        append_macro('NDEBUG')
      end
      @props = [ '$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props' ]
    end
    attr_reader :name, :platform
    attr_reader :props
    attr_accessor :platform, :is_debug

    #
    def to_s
      return "#{@name}|#{@platform}"
    end

    #
    def condition
      return "'$(Configuration)|$(Platform)'=='#{to_s}'"
    end
  end
end
